HotLoot = LibStub("AceAddon-3.0"):NewAddon("HotLoot", "AceConsole-3.0", "AceEvent-3.0")

-- options
local options = {
    name = "HotLoot",
    handler = HotLoot,
    type = "group",
    args = {
		lootDesc = {
			name = "HotLoot is an autoloot filter designed to streamline the looting process. This AddOn allow you to automatically loot various items related to professions and quests.",			
			type = "description",
			order = 0
		},
		spacer1 = {
			name = "   ",			
			type = "description",
			order = 1
		},
		lootDesc3 = {
			name = "NOTE: In order for HotLoot to work effectively please ensure that all other autoloot AddOns and options are turned off.",  
			type = "description",
			order = 2
		},
		lootEnabled = {
			name = "Enable",
			desc = "check to enable HotLoot",
			type = "toggle",
			set = "setLootEnabled",
			get = "getLootEnabled",
			order = 3
		},
		lootDebug = {
			name = "Debug Mode",
			desc = "check to enable debugging",
			type = "toggle",
			set = "setLootDebug",
			get = "getLootDebug",
			order = 4
		},
		lootClose = {
			name = "Close Loot Window",
			desc = "check to automatically close the loot window after autolooting\n\nhold Ctrl to temporarily disable while looting",
			type = "toggle",
			set = "setLootClose",
			get = "getLootClose",
			order = 5
		},
		lootConfigHeader = {
			name = "Autoloot Options",
			type = "header",
			order = 6
		},
		lootGold = {
			name = "Loot Gold",
			desc = "check to autoloot gold",
			type = "toggle",
			set = "setLootGold",
			get = "getLootGold",
			order = 7
		},
		lootQuest = {
			name = "Loot Quest Items",
			desc = "check to autoloot quest items",
			type = "toggle",
			set = "setLootQuest",
			get = "getLootQuest",
			order = 8
		},
		lootJunk = {
			name = "Loot Junk",
			desc = "check to autoloot junk (grey items)",
			type = "toggle",
			set = "setLootJunk",
			get = "getLootJunk",
			order = 9
		},
		lootCloth = {
			name = "Loot Cloth",
			desc = "check to autoloot cloth",
			type = "toggle",
			set = "setLootCloth",
			get = "getLootCloth",
			order = 10
		},
		lootMining = {
			name = "Loot Mining",
			desc = "check to enable mining looting options",
			type = "toggle",
			set = "setLootMining",
			get = "getLootMining",
			order = 11
		},
		lootGems = {
			name = "Loot Gems",
			desc = "check to autoloot gems",
			type = "toggle",
			set = "setLootGems",
			get = "getLootGems",
			order = 12
		},
		--[[
		miningOptions = {
			name = "miningOptions",
			type = "group"
			args = {
				lootOre = {
					name = "Loot Ore",
					desc = "check to autoloot ore",
					type = "toggle",
					set = "setLootOre",
					get = "getLootOre",
					--order = 100
				},
				lootStone = {
					name = "Loot Stone",
					desc = "check to autoloot stone",
					type = "toggle",
					set = "setLootStone",
					get = "getLootStone",
					--order = 100
				},
				lootGems = {
					name = "Loot Gems",
					desc = "check to autoloot gems",
					type = "toggle",
					set = "setLootGems",
					get = "getLootGems",
					--order = 100
				},
			},
		},
		]]
		lootHerbs = {
			name = "Loot Herbs",
			desc = "check to autoloot herbs",
			type = "toggle",
			set = "setLootHerbs",
			get = "getLootHerbs",
			order = 13
		},
		lootSkinning = {
			name = "Loot Leather",
			desc = "check to autoloot leather",
			type = "toggle",
			set = "setLootSkinning",
			get = "getLootSkinning",
			order = 14
		},
		lootFishing = {
			name = "Loot Fishing",
			desc = "check to autoloot fishing",
			type = "toggle",
			set = "setLootFishing",
			get = "getLootFishing",
			order = 15
		},
		lootPots = {
			name = "Loot Potions",
			desc = "check to autoloot potions",
			type = "toggle",
			set = "setLootPots",
			get = "getLootPots",
			order = 16
		},
		lootMoH = {
			name = "Loot Motes of Harmony",
			desc = "check to autoloot motes of harmony",
			type = "toggle",
			set = "setLootMoH",
			get = "getLootMoH",
			order = 17
		},
		spacer2 = {
			name = "   ",			
			type = "description",
			order = 18
		},
		excludeDesc = {
			name = "Exclude List",			
			type = "description",
			order = 19
		},
		excludeList = {
			name = "Here you can write items you want excluded from autolooting (ie. Linen Cloth, Iron Ore)",
			multiline = 7,
			type = "input",
			set = "setExcludeList",
			get = "getExcludeList",
			width = "full",
			order = 20
		},
		spacer3 = {
			name = "   ",			
			type = "description",
			order = 21
		},
		includeDesc = {
			name = "Include List",			
			type = "description",
			order = 22
		},
		includeList = {
			name = "Here you can write items you want to include when autolooting (ie. Linen Cloth, Iron Ore)",
			multiline = 7,
			type = "input",
			set = "setIncludeList",
			get = "getIncludeList",
			width = "full",
			order = 23
		},
		--[[
		lootGreen = {
			name = "Loot Green Items",
			desc = "check to autoloot green items",
			type = "toggle",
			set = "setLootGreen",
			get = "getLootGreen",
			--order = 100
		},
		lootBlue = {
			name = "Loot Blue Items",
			desc = "check to autoloot blue items",
			type = "toggle",
			set = "setLootBlue",
			get = "getLootBlue",
			--order = 100
		},
		
		lootCustom = {
			name = "Loot Blue Items",
			desc = "check to autoloot blue items",
			type = "toggle",
			set = "setLootBlue",
			get = "getLootBlue",
			--order = 100
		},
		]]
    },
}

--[[
local chatCmd = {
	name = "chatOptions",
	handler = "HotLoot",
	type = "group",
	args = {
		lootDebug = {
			name = "lootDebug",
			type = "toggle",
			set = "setLootDebug",
			get = "getLootDebug"
		}
	}
}
]]

-- Config Defaults
local defaults = {
	char = {
		lootEnabled = true,
		lootDebug = false,
		lootClose = false,
		lootGold = true,
		lootQuest = false,
		lootJunk = false,
		lootCloth = false,
		lootMining = false,
		--[[
		miningOptions = {
			lootOre = false,
			lootStone = false,
			lootGems = false
		},
		]]
		lootGems = false,
		lootHerbs = false,
		lootSkinning = false,
		lootFishing = false,
		--[[
		fishingOptions = {
			lootFish = true,
			lootFishJunk = true
		},
		]]
		lootPots = false,
		lootMoH = false,
		lootGreen = false,
		lootBlue = false,
		lootCustom = false,
		excludeList = "",
		includeList = "",
	}
}
local checkSubType = {"Gold", "Quest", "Junk", "Cloth", "Metal & Stone", "lootGold", "lootGold", "lootGold", "lootGold", "lootGold", };
-- inirialize
function HotLoot:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("HotLootDB", defaults, true)
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HotLoot", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HotLoot", "HotLoot")
    self:RegisterChatCommand("hl", "ChatCommand")
    self:RegisterChatCommand("hotloot", "ChatCommand")
end

-- enable
function HotLoot:OnEnable()
	--HotLootDB:RegisterDefaults(defaults);
	--self.db.char.lootDebug = 1;
end

-- slash cmd handler 

function HotLoot:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0"):HandleCommand("hl", "HotLoot", input)
    end
end

-- debug mode
local function lDebug(name, value)
	if (HotLoot:getLootDebug() == true) then
		print(tostring(name) .. " = " .. tostring(value));
	end
end

-- HotLoot autoloot modudle
local frame = CreateFrame("FRAME", "HotLootFrame");
frame:RegisterEvent("LOOT_OPENED");
local function eventHandler(self, event, ...)
	if (HotLoot:getLootEnabled() == true) then
		local arg1, numSlots, curSlot, slotCounter;
		numSlots = GetNumLootItems();
		arg1 = ...;
		slotCounter = 1;
		curSlot = 1;
		-- check if turned on
		--[[
		local hLootSlot(slot)
			LootSlot(slot);
			if (HotLoot:getLootDebug() == true) then
				-- print
			end
		end
		]]
		local ctrlDown = IsControlKeyDown();
		
		while (curSlot <= numSlots) do
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice;
			local lootLink;
			local lootIcon, lootName, lootQuantity, rarity, locked;
			lootIcon, lootName, lootQuantity, rarity, locked = GetLootSlotInfo(curSlot);
			-- check if its gold
			if lootQuantity > 0 then						
				lootLink = GetLootSlotLink(curSlot);
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(lootLink);
			else
				itemName = "Gold";
				itemLink = "[Gold]";
				itemType = "Currency";
				itemSubType = "Gold";
			end
			--[[
			-- inclusion list
			local il = HotLoot:getExcludeList();
			if il == nil then
				il = " ";
			end
			
			-- exclusion list
			local el = HotLoot:getExcludeList();
			if el == nil then
				el = " ";
			end
			]]
			if (string.find(HotLoot:getExcludeList(), itemName) ~= nil) then
				-- Don't Loot
				if (HotLoot:getLootDebug() == true) then
					print("Slot " .. curSlot .. " has been excluded.");
				end
			else
			-- switch?
			if 
				(itemSubType == "Gold") and (HotLoot:getLootGold() == true) then LootSlot(curSlot) -- Gold
			elseif
				(itemType == "Quest") and (HotLoot:getLootQuest() == true) then LootSlot(curSlot) -- Quest
			elseif
				(itemSubType == "Junk") and (HotLoot:getLootJunk() == true) then LootSlot(curSlot) -- Junk
			elseif
				(itemSubType == "Cloth") and (itemType == "Trade Goods") and (HotLoot:getLootCloth() == true) then LootSlot(curSlot) -- Cloth
			elseif
				(itemSubType == "Metal & Stone") and (HotLoot:getLootMining() == true) then LootSlot(curSlot) -- Mining
			elseif
				(itemType == "Gem") and (HotLoot:getLootGems() == true) then LootSlot(curSlot) 
			elseif
				(itemSubType == "Herb") and (HotLoot:getLootHerbs() == true) then LootSlot(curSlot) 
			elseif
				(itemSubType == "Leather") and (HotLoot:getLootSkinning() == true) then LootSlot(curSlot) 
			elseif
				(IsFishingLoot()) and (HotLoot:getLootFishing() == true) then LootSlot(curSlot) 
			elseif
				(itemSubType == "Potion") and (HotLoot:getLootPots() == true) then LootSlot(curSlot) 
			elseif
				(itemName == "Mote of Harmony") and (HotLoot:getLootMoH() == true) then LootSlot(curSlot) 
			elseif
				(string.find(HotLoot:getIncludeList(), itemName) ~= nil) then LootSlot(curSlot)
			end
			end
			--[[
			elseif
				(itemSubType = "Potion") and (HotLoot:getLootPots() == true) then LootSlot(curSlot) 
			elseif
				(itemSubType = "Potion") and (HotLoot:getLootPots() == true) then LootSlot(curSlot) 
			]]
			-- debug mode
			--[[
			if (HotLoot:getLootDebug() == true) then
				print("---------------");
				print("Slot " .. curSlot .. ": " .. itemLink);
				print("Item type: " .. itemType);
				print("Item sub type: " .. itemSubType);
				print("---------------");
			end
			]]
			-- switch
			curSlot = curSlot + 1;
		end
		-- close window
		lDebug("ctrlDown", ctrlDown);
		if (HotLoot:getLootClose() == true) and (ctrlDown == nil) then
			CloseLoot();
		end
	end
end
frame:SetScript("OnEvent", eventHandler);

--		SAVE FOR DEBUG





-- set/get functions

-- lootEnabled
function HotLoot:setLootEnabled(info, value)
	self.db.char.lootEnabled = value;
	lDebug("lootEnabled", value);
end
function HotLoot:getLootEnabled(info)
	return self.db.char.lootEnabled;
end

-- lootGold
function HotLoot:setLootGold(info, value)
	self.db.char.lootGold = value;
	lDebug("lootGold", value);
end
function HotLoot:getLootGold(info)
	return self.db.char.lootGold;
end

-- lootQuest
function HotLoot:setLootQuest(info, value)
	self.db.char.lootQuest = value;
	lDebug("lootQuest", value);
end
function HotLoot:getLootQuest(info)
	return self.db.char.lootQuest;
end

-- lootJunk
function HotLoot:setLootJunk(info, value)
	self.db.char.lootJunk = value;
	lDebug("lootJunk", value);
end
function HotLoot:getLootJunk(info)
	return self.db.char.lootJunk;
end

-- lootDebug
function HotLoot:setLootDebug(info, value)
	self.db.char.lootDebug = value;
	lDebug("lootDebug", value);
end
function HotLoot:getLootDebug(info)
	return self.db.char.lootDebug;
end

-- lootClose
function HotLoot:setLootClose(info, value)
	self.db.char.lootClose = value;
	lDebug("lootClose", value);
end
function HotLoot:getLootClose(info)
	return self.db.char.lootClose;
end

--lootCloth
function HotLoot:setLootCloth(info, value)
	self.db.char.lootCloth = value;
	lDebug("lootCloth", value);
end
function HotLoot:getLootCloth(info)
	return self.db.char.lootCloth;
end

--lootMining
function HotLoot:setLootMining(info, value)
	self.db.char.lootMining = value;
	lDebug("lootMining", value);
end
function HotLoot:getLootMining(info)
	return self.db.char.lootMining;
end

--lootOre
--[[function HotLoot:setLootOre(info, value)
	self.db.char.lootOre = value;
	lDebug("lootOre", value);
end
function HotLoot:getLootOre(info)
	return self.db.char.lootOre;
end

--lootStone
function HotLoot:setLootStone(info, value)
	self.db.char.lootStone = value;
	lDebug("lootStone", value);
end
function HotLoot:getLootStone(info)
	return self.db.char.lootStone;
end
]]
--lootGems
function HotLoot:setLootGems(info, value)
	self.db.char.lootGems = value;
	lDebug("lootGems", value);
end
function HotLoot:getLootGems(info)
	return self.db.char.lootGems;
end

--lootHerbs
function HotLoot:setLootHerbs(info, value)
	self.db.char.lootHerbs = value;
	lDebug("lootHerbs", value);
end
function HotLoot:getLootHerbs(info)
	return self.db.char.lootHerbs;
end

--lootSkinning
function HotLoot:setLootSkinning(info, value)
	self.db.char.lootSkinning = value;
	lDebug("lootSkinning", value);
end
function HotLoot:getLootSkinning(info)
	return self.db.char.lootSkinning;
end

--lootFishing
function HotLoot:setLootFishing(info, value)
	self.db.char.lootFishing = value;
	lDebug("lootFishing", value);
end
function HotLoot:getLootFishing(info)
	return self.db.char.lootFishing;
end

--lootFish
--[[function HotLoot:setLootFish(info, value)
	self.db.char.lootFish = value;
	lDebug("lootFish", value);
end
function HotLoot:getLootFish(info)
	return self.db.char.lootFish;
end

--lootFishJunk
function HotLoot:setLootFishJunk(info, value)
	self.db.char.lootFishJunk = value;
	lDebug("lootFishJunk", value);
end
function HotLoot:getLootFishJunk(info)
	return self.db.char.lootFishJunk;
end]]

--lootPots
function HotLoot:setLootPots(info, value)
	self.db.char.lootPots = value;
	lDebug("lootPots", value);
end
function HotLoot:getLootPots(info)
	return self.db.char.lootPots;
end

--lootMoH
function HotLoot:setLootMoH(info, value)
	self.db.char.lootMoH = value;
	lDebug("lootMoH", value);
end
function HotLoot:getLootMoH(info)
	return self.db.char.lootMoH;
end

--excludeList
function HotLoot:setExcludeList(info, value)
	self.db.char.excludeList = value;
	lDebug("excludeList", value);
end
function HotLoot:getExcludeList(info)
	return self.db.char.excludeList;
end

--includeList
function HotLoot:setIncludeList(info, value)
	self.db.char.includeList = value;
	lDebug("includeList", value);
end
function HotLoot:getIncludeList(info)
	return self.db.char.includeList;
end
--[[
--lootGreen
function HotLoot:setLootGreen(info, value)
	self.db.char.lootGreen = value;
	lDebug("lootGreen", value);
end
function HotLoot:getLootGreen(info)
	return self.db.char.lootGreen;
end

--lootBlue
function HotLoot:setLootBlue(info, value)
	self.db.char.lootBlue = value;
	lDebug("lootBlue", value);
end
function HotLoot:getLootBlue(info)
	return self.db.char.lootBlue;
end
]]
--lootCustom
--[[function HotLoot:setLootCustom(info, value)
	self.db.char.lootCustom = value;
	lDebug("lootCustom", value);
end
function HotLoot:getLootCustom(info)
	return self.db.char.lootCustom;
end]]
